Index: src/iax.c
===================================================================
RCS file: /usr/cvsroot/libiax2/src/iax.c,v
retrieving revision 1.16
diff -u -r1.16 iax.c
--- src/iax.c	19 Nov 2003 23:04:05 -0000	1.16
+++ src/iax.c	25 Nov 2003 03:55:42 -0000
@@ -2418,9 +2418,25 @@
 	if (blocking) {
 		/* Block until there is data if desired */
 		fd_set fds;
+		int nextEventTime;
+
 		FD_ZERO(&fds);
 		FD_SET(netfd, &fds);
-		select(netfd + 1, &fds, NULL, NULL, NULL);
+	
+		nextEventTime = iax_time_to_next_event(); 
+
+		if(nextEventTime < 0) 
+			select(netfd + 1, &fds, NULL, NULL,NULL); 
+		else 
+		{ 
+			struct timeval nextEvent; 
+
+			nextEvent.tv_sec = nextEventTime / 1000; 
+			nextEvent.tv_usec = (nextEventTime % 1000) * 1000;
+
+			select(netfd + 1, &fds, NULL, NULL, &nextEvent); 
+		} 
+
 	}
 	event = iax_net_read();
 	
